function [ks,imax,S_tot,K_tot,epsilon_tot, Maxdiff_tot,epsilon_0i_tot,epsilon_p0i_tot,sigma_p0i_tot,sigma_c0i_tot,sigma_s0j_tot,q,R,S_plot, R_plot, UR_C, UR_S, UR_vc] = hoved(nx,ny,nxy,mx,my,mxy,h,c1,c2,n,n_iterasjoner,beta,Asx1,Asx2,Asy1,Asy2,f_sk,E_sint,f_ck,E,n_eksp,v,epsilon_c1,epsilon_c2,epsilon_c3,epsilon_cu1,epsilon_cu2,epsilon_cu3, betongmat, stalmat, fctm, V_x,V_y,As_vx,As_vy,Sx,Sy)

%Input verdier%

%Eksterne krefter
%Skaleres til N/mm og Nmm/mm

%Skalere mx og my
mx=mx*1000;
my=my*1000;
mxy=1000*mxy;

R = [nx; ny; nxy; mx; my; mxy];

%Geometri

%Armerings arm
z_s=[h/2-c1,-h/2+c1,h/2-c1,-h/2+c2];

%Oppdeling i lag
delta_h = h/n;
z=1:n-1;
for i = 0:1:n-1;
    z(i+1) = ((-(h/2)+(delta_h/2)) +(delta_h*i));
end
z=transpose(z);

%Material
%Betong
v1=v;
alpha_cc = 0.85;
gamma_c = 1.5;
f_cd = alpha_cc*(f_ck/gamma_c);

epsilon_c1 = -epsilon_c1;
epsilon_c2 = -epsilon_c2;
epsilon_c3 = -epsilon_c3;
epsilon_cu1 = -epsilon_cu1;
epsilon_cu2 = -epsilon_cu2;
epsilon_cu3 = -epsilon_cu3;

%Bestemmer E-modulen
if betongmat == 1
    E = abs(f_cd/epsilon_c3);
elseif betongmat == 2
     E = abs(f_cd/epsilon_c2);
elseif betongmat == 3
    maxe = 1;
    f_cm = f_cd + (8*0.85/1.5);
    fcm4 = 0.4*f_cm;
    epsilon_e = fcm4/E;
    ek=1;

    while ek > 0.001 && maxe < 200
        maxe = maxe+1;
        k = (1.05*E*epsilon_c1)/f_cm;
        eta = epsilon_e/epsilon_c1;
        oc = f_cm*((k*eta-eta^2)/(1+(k-2)*eta));
        E = oc/epsilon_e;
        epsilon_e = fcm4/E;
        ek = abs(oc-fcm4);
    end
end
E = abs(E);
%Deler opp v for alle betonglagene
v=zeros(1,20);
for i =1:n;
    v(i) = v1;
end

%Material matrise betong

E11=E; 
E12=E;
E22=E;

C = zeros(3,3*n);
for i = 0:1:n-1;
    C(1,3*i+1)=(1/(1-v(i+1)^2))*E11;
    C(1,3*i+2)=(1/(1-v(i+1)^2))*v(i+1)*E12;
    C(2,3*i+1)=(1/(1-v(i+1)^2))*v(i+1)*E12;
    C(2,3*i+2)=(1/(1-v(i+1)^2))*E22;
    C(3,3*i+3)=(1/(1-v(i+1)^2))*((1-v(i+1))*E12)/2;
end

%Armering%

gamma_s = 1.15;
f_sd = f_sk/gamma_s;

epsilon_s02=f_sd/E_sint;

%Material matrise armering
C_s = zeros(3,12);
C_s(1,1) = E_sint;
C_s(1,4) = E_sint;
C_s(2,8) = E_sint;
C_s(2,11) = E_sint;


As = [Asx1, Asx2, Asy1, Asy2];

%Definerer variabler for iterasjons kontroll
ks=1;
imax=0;

%Kjrer steg.m hvor iterasjons prossesen foregr
%For  mle tid p utregningen fjern % forran tic og toc
%tic
[ks,imax,S_tot,K_tot,epsilon_tot, Maxdiff_tot,epsilon_0i_tot,epsilon_p0i_tot,sigma_p0i_tot,sigma_c0i_tot,sigma_s0j_tot, epsilon_s0j_tot] = steg(C,z,delta_h,n,As,C_s,z_s,R,epsilon_c1,epsilon_c2,epsilon_c3,epsilon_cu1,epsilon_cu2,epsilon_cu3,f_cd,n_eksp,v,epsilon_s02,E_sint,f_sd,imax,ks,beta,n_iterasjoner, betongmat,E,stalmat,v1,fctm,h); 
%toc
%Klargjr matriser for plotting
K_tot = K_tot(1:6,1:6*imax);
epsilon_tot = epsilon_tot(1:6,1:imax);
S_plot = zeros(6,2*imax);
R_plot = zeros(6,2*imax);

%Utnyttelse ratioer
epsilon_c = min(epsilon_p0i_tot(1:3,(n*imax-(n-1)):n*imax));
epsilon_s = zeros(4,1);
epsilon_st = epsilon_s0j_tot(1:3,imax*4-(4-1):imax*4);
epsilon_s(1,1) = epsilon_st(1,1);
epsilon_s(2,1) = epsilon_st(1,2);
epsilon_s(3,1) = epsilon_st(2,3);
epsilon_s(4,1) = epsilon_st(2,4);

%Skjrkraft beregning
[UR_vc] = skjarkontroll(f_cd,As,h,c1,c2,Sx,Sy,R,As_vx,As_vy,f_sd,V_x,V_y);

%Kjrer ur.m for  bestemme utnyttelse ratioer
[UR_C,UR_S] = ur(epsilon_cu1,epsilon_cu2,epsilon_cu3,epsilon_c, epsilon_s, As, betongmat);

%Variabler brukt til plotting
for q=1:1:(2*imax);
    if rem(q,2) == 0;
        S_plot(1:6,q) = S_tot(1:6,q/2);
    else
        S_plot(1:6,q) = zeros(6,1);
    end
    R_plot(1:6,q)=R(1:6);
end

q=zeros(1,2*imax);
tt = 1:1:imax;

for i=2:2:2*imax;
    q(i) = tt(i/2);
end

for i=3:2:2*imax-1;
    q(i) = tt(i/2 -0.5);
end