function [S_s, sigma_s0jt, epsilon_0j, C_s] = s_s(z_s, epsilon_t0, epsilon_s02, f_sd, E_sint, As, stalmat,imax)

%Definerer matriser og material konstanter
epsilon_0j = zeros(3,4);

epsilon_uk = 0.05;
epsilon_ud = 0.9*epsilon_uk;
k = 1.08;

%Finner tyninger i armeringslagene
for i = 1:4
    if As(i) == 0
        epsilon_0j(1:3,i) = [0;0;0];
    else
        epsilon_0j(1:3,i) = [1 0 0 -z_s(i) 0 0;0 1 0 0 -z_s(i) 0;0 0 1 0 0 -z_s(i)]*epsilon_t0;
    end
end

%Finner armerings spenninger
sigma_s0j = zeros(3,4); 

%Velger material modell
if stalmat == 1
    %Flat modell
    for i = 1:4;
        if abs(epsilon_0j(1,i)) < epsilon_s02;
            sigma_s0j(1,i) = E_sint*epsilon_0j(1,i);
            if abs(epsilon_0j(1,i)) > epsilon_uk;
                sigma_s0j(1,i) = 0;
            end
        else
            sigma_s0j(1,i) = f_sd*sign(epsilon_0j(1,i));
        end
    end

    for i = 1:4;
        if abs(epsilon_0j(2,i)) < epsilon_s02;
            sigma_s0j(2,i) = E_sint*epsilon_0j(2,i);
            if abs(epsilon_0j(2,i)) > epsilon_uk;
                sigma_s0j(2,i) =0;
            end
        else
            sigma_s0j(2,i) = f_sd*sign(epsilon_0j(2,i));
        end
    end
elseif stalmat ==2
    %Stigende modell
   for i = 1:4;
       if abs(epsilon_0j(1,i)) >= epsilon_s02
           sigma_s0j(1,i) = sign(epsilon_0j(1,i))*f_sd + (f_sd*(k-1))*(epsilon_0j(1,i)/epsilon_ud);
            if abs(epsilon_0j(1,i)) > epsilon_ud
               sigma_s0j(1,i) = 0;
            end
       else
           sigma_s0j(1,i) = E_sint*epsilon_0j(1,i);
       end
       
       if abs(epsilon_0j(2,i)) >= epsilon_s02
           sigma_s0j(2,i) = sign(epsilon_0j(2,i))*f_sd + (f_sd*(k-1))*(epsilon_0j(2,i)/epsilon_ud);
           if abs(epsilon_0j(2,i)) > epsilon_ud
               sigma_s0j(2,i) = 0;
           end
       else
           sigma_s0j(2,i) = E_sint*epsilon_0j(2,i);
       end
   end
end

%Kalkulerer ny materialmatrise for armering

Esx= [0 0];
Esy = [0 0];

%Velger material modell
if stalmat == 1
    %Flat modell
    for i =1:2;
        if epsilon_0j(1,i) == 0 
            Esx(i) = 0;
        else
            Esx(i) = sigma_s0j(1,i)/epsilon_0j(1,i);
        end
    end
    for i =3:4;
        if epsilon_0j(2,i) == 0 
            Esy(i-2) = 0;
        else
            Esy(i-2) = sigma_s0j(2,i)/epsilon_0j(2,i);
        end
    end
elseif stalmat == 2;
    for i = 1:2;
        if epsilon_0j(1,i) == 0 
            Esx(i) = 0;
        else
            Esx(i) = (sigma_s0j(1,i)/epsilon_0j(1,i));
        end
    end
    for i = 3:4;
        if epsilon_0j(2,i) == 0 
            Esy(i-2) = 0;
        else
            Esy(i-2) = (sigma_s0j(2,i)/epsilon_0j(2,i));
        end
    end
end

%Lager ny material matrise

C_s = zeros(3,12);
C_s(1,1) = Esx(1);
C_s(1,4) = Esx(2);

C_s(2,8) = Esy(1);
C_s(2,11) = Esy(2);


%Finner armeringsspenningene basert p ny materialmatrise
sigma_s0j = zeros(3,4);

sigma_s0j(1,1) = C_s(1,1)*epsilon_0j(1,1);
sigma_s0j(1,2) = C_s(1,4)*epsilon_0j(1,2);
sigma_s0j(2,3) = C_s(2,8)*epsilon_0j(2,3);
sigma_s0j(2,4) = C_s(2,11)*epsilon_0j(2,4);

%Finner internekrefter fra armeringen
S_s = zeros(6,1);

for i = 1:2;
    S_s(1) = S_s(1) + sigma_s0j(1,i)*As(i);  
    S_s(2) = S_s(2) + sigma_s0j(2,i+2)*As(i+2);
    S_s(4) = S_s(4) - z_s(i)*sigma_s0j(1,i)*As(i);
    S_s(5) = S_s(5) - z_s(i+2)*sigma_s0j(2,i+2)*As(i+2);
end
sigma_s0jt = [sigma_s0j(1,1); sigma_s0j(1,2); sigma_s0j(2,3); sigma_s0j(2,4)];


