function [ks,imax,S_tot,K_tot,epsilon_tot, Maxdiff_tot,epsilon_0i_tot,epsilon_p0i_tot,sigma_p0i_tot,sigma_c0i_tot,sigma_s0j_tot, epsilon_s0j_tot] = steg(C,z,delta_h,n,As,C_s,z_s,R,epsilon_c1,epsilon_c2,epsilon_c3,epsilon_cu1,epsilon_cu2,epsilon_cu3,f_cd,n_eksp,v,epsilon_s02,E_sint,f_sd,imax,ks,beta,n_iterasjoner, betongmat,E,stalmat,v1,fctm,h)  

%Opprettelse av matriser fr iterasjonen starter
K_tot = zeros(6,6*n_iterasjoner);
epsilon_tot = zeros(6,n_iterasjoner);
epsilon_0i_tot = zeros(3,n*n_iterasjoner);
epsilon_p0i_tot = zeros(3,n*n_iterasjoner);
sigma_p0i_tot = zeros(3,n*n_iterasjoner);
sigma_c0i_tot = zeros(3,n*n_iterasjoner);
sigma_s0j_tot = zeros(4,n_iterasjoner);
S_tot = zeros(6,n_iterasjoner);
Maxdiff_tot = zeros(6,n_iterasjoner);
epsilon_s0j_tot = zeros(3,4*n_iterasjoner);

%Betong material konstanter
%Finner tyningsgrense for riss i betongen

fctm = max((1.6-(h/1000)*fctm),fctm);
fctm = 0.85*fctm/1.5;

if betongmat == 1;
    epsilon_cs = abs(fctm/(f_cd/epsilon_c3));
elseif betongmat ==2;
    epsilon_cs = abs((1-((1-(fctm/f_cd))^(1/n_eksp)))*epsilon_c2);
elseif betongmat == 3;
    f_cm = f_cd + (8*0.85/1.5);
    k_il = 1.05*E*abs(epsilon_c1)/f_cm;
    o_il = fctm/f_cm;
    A_il = 1;
    B_il = o_il*(k_il-2)-k_il;
    C_il = o_il;
    eta2 = (-B_il - sqrt((B_il^2)-4*A_il*C_il))/(2*A_il);
    epsilon_cs = abs(eta2*epsilon_c1);
end


%Starter iterasjons prosessen som kjrer frem til et av kravene er mtt

while (ks>beta && imax<n_iterasjoner)

%Teller antall iterasjoner kjrt
imax=imax+1;    


%Kjrer kc.m for  danne stivhetsmatrisen for betong
[K_c0] = kc(C,z,delta_h,n);


%Kjrer k_s. for  danne stivhetsmatrisen for armeringen
[K_s] = k_s(As,C_s,z_s);
%Total stivhet
K_0 = K_s + K_c0;

%Samler stivhetsmatrisen i en matrise for plotting
K_tot(1:6,(6*imax-5):(6*imax)) = K_0;

%Finne tyninger i midten av skall planet
%M sjekke hvilken inverterings metode som brukes

epsilon_t0=zeros(6,1);

if cond(K_0)>1e10;
    epsilon_t0 = pinv(K_0)*R;
else
    epsilon_t0 = K_0\R;
end

%Samler totale tyninger i en matrise for plotting

epsilon_tot(1:6,imax) = epsilon_t0;

%Finner tyningene i planet i hvert betong lag

epsilon_0i = zeros(3,n);

for i=1:1:n;
    epsilon_0i(1:3,i)=[1,0,0,-z(i),0,0;0,1,0,0,-z(i),0;0,0,1,0,0,-z(i)]*epsilon_t0;
end


%Samles i matrise for plotting

epsilon_0i_tot(1:3,(n*imax-(n-1)):n*imax) = epsilon_0i;

%Finne hovedtyninger og hoved retninger i betonglagene

theta_i = zeros(1,n);

for i=1:1:n;
    theta_i(i)=0.5*atan((epsilon_0i(3,i))/(epsilon_0i(1,i)-epsilon_0i(2,i)));
end

%Transformasjons matrise

T = zeros(3,3*n);
 
 for i=0:1:n-1;
     T(1,(3*i)+1) = cos(theta_i(i+1))^2;
     T(1,(3*i)+2) = sin(theta_i(i+1))^2;
     T(1,(3*i)+3) = sin(theta_i(i+1))*cos(theta_i(i+1));
     T(2,(3*i)+1) = sin(theta_i(i+1))^2;
     T(2,(3*i)+2) = cos(theta_i(i+1))^2;
     T(2,(3*i)+3) = -sin(theta_i(i+1))*cos(theta_i(i+1));
     T(3,(3*i)+1) = -2*sin(theta_i(i+1))*cos(theta_i(i+1));
     T(3,(3*i)+2) = 2*sin(theta_i(i+1))*cos(theta_i(i+1));
     T(3,(3*i)+3) = (cos(theta_i(i+1))^2)-(sin(theta_i(i+1))^2);
 end

%Transformerer tyningene
epsilon_p0i = zeros(3,n);

for i=0:1:n-1;
    epsilon_p0i(1:3,i+1) = T(1:3,((3*i)+1):(3*i)+3)*epsilon_0i(1:3,i+1);
end

%Samles i matrise for plotting
epsilon_p0i_tot(1:3,(n*imax-(n-1)):n*imax) = epsilon_p0i;

%Nullsetter elasitets modulene for hvert lag 
E11_ri = zeros(n,1);
E22_ri = zeros(n,1);
E12_ri = zeros(n,1);

sigma_p0i = zeros(3,n);

%Her er det mulig  velge om betongen skal ha noen tyningskapasitet sett
%tverrmatr = 1 for at betongen skal f kapasitet
tverrmatr = 0;

%Kjrer betongmatr.m for  finne betongspenninger og ny elasitetsmodul

[sigma_p0i,E11_ri,E22_ri,E12_ri] = betongmatr(betongmat,imax,n,f_cd,n_eksp,v,epsilon_p0i,epsilon_c1,epsilon_c2,epsilon_c3,epsilon_cu1,epsilon_cu2,epsilon_cu3, E,sigma_p0i,E11_ri,E22_ri,E12_ri,tverrmatr,epsilon_cs);

%Samles i matrise for plotting

sigma_p0i_tot(1:3,(n*imax-(n-1)):n*imax) = sigma_p0i;


%Sjekker om betongen er i tyning i hvert lag for  sette v verdiene


if tverrmatr == 1
    for  i= 1:n;
        if epsilon_p0i(1,i) >=epsilon_cs;
            v(i) = 0;
        elseif epsilon_p0i(2,i) >=epsilon_cs;
            v(i) = 0;
        end
    end
else
        for  i= 1:n;
            if epsilon_p0i(1,i) >=0;
                v(i) = 0;
            elseif epsilon_p0i(2,i) >=0;
                v(i) = 0;
            else
                v(i) = v1;
            end
        end
end

%Lager ny material matrise for betongen

C_p = zeros(3,3*n);

for i=0:1:n-1;
    C_p(1,3*i+1)=(1/(1-(v(i+1)^2)))*E11_ri(i+1);
    C_p(1,3*i+2)=(1/(1-(v(i+1)^2)))*v(i+1)*E12_ri(i+1);
    C_p(2,3*i+1)=(1/(1-(v(i+1)^2)))*v(i+1)*E12_ri(i+1);
    C_p(2,3*i+2)=(1/(1-(v(i+1)^2)))*E22_ri(i+1);
    C_p(3,3*i+3)=(1/(1-(v(i+1)^2)))*((1-v(i+1))*E12_ri(i+1))/2;
end


C_test = C_p;

%Transformerer material matrisen til x og y retninger
C = zeros(3,3*n);

for i=0:1:n-1;
    C(1:3,((3*i)+1):(3*i)+3) = transpose(T(1:3,((3*i)+1):(3*i)+3))*C_p(1:3,((3*i)+1):(3*i)+3)*(T(1:3,((3*i)+1):(3*i)+3));
end

%Betong spenninger basert p materialmatrisen

sigma_cpi = zeros(3,n);

for i=0:1:n-1;
    sigma_cpi(1:3,i+1) =  C_test(1:3,((3*i)+1):(3*i)+3)*epsilon_p0i(1:3,i+1);
end

%Betong spenninger i x og y retning

sigma_c = zeros(3,n);

for i=0:1:n-1;  
    sigma_c(1:3,i+1) = transpose(T(1:3,((3*i)+1):(3*i)+3))*sigma_cpi(1:3,i+1);
end

%Samles i matrise for plotting
sigma_c0i_tot(1:3,(n*imax-(n-1)):imax*n) = sigma_c;

%Kjrer s_s for  finne armerings spenninger i hvert armerings lag og
%interne krefter fra armering

[S_s, sigma_s0jt, epsilon_s0j, C_s] = s_s(z_s, epsilon_t0, epsilon_s02, f_sd, E_sint, As, stalmat,imax);

%Samles i matrise for plotting
epsilon_s0j_tot(1:3,imax*4-(4-1):imax*4) = epsilon_s0j;

sigma_s0j_tot(1:4,imax) = sigma_s0jt;

S_0c = zeros(6,1);
 
%Interne krefter fra betongen
 
 for i =1:1:n;
     S_0c(1,1) = S_0c(1,1) + sigma_c(1,i)*delta_h;
     S_0c(2,1) = S_0c(2,1) + sigma_c(2,i)*delta_h;
     S_0c(3,1) = S_0c(3,1) + sigma_c(3,i)*delta_h;
     S_0c(4,1) = S_0c(4,1) - z(i)*sigma_c(1,i)*delta_h;
     S_0c(5,1) = S_0c(5,1) - z(i)*sigma_c(2,i)*delta_h;
     S_0c(6,1) = S_0c(6,1) - z(i)*sigma_c(3,i)*delta_h;
 end

 
 S_0 = S_0c + S_s;
 
 %Samles i matrise for plotting
 S_tot(1:6,imax)=S_0;
 
 %Finner maksimum relativ differanse mellom komponentene av ekstern og intern
 %spenningsresultanter
 Maxdiff = zeros(6,1);
 
for k=1:1:6;
    if R(k) == 0;
        Maxdiff(k,1) = 0;
    else
        Maxdiff(k,1) = abs((S_0(k)-R(k))/R(k));
    end
end
Maxdiff_tot(1:6,imax) = Maxdiff;
ks=max(Maxdiff);
end

